package de.hs_mannheim.informatik.domain;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.ArrayList;

public class CSVReader {
	
    public ArrayList<String> readFromFile(InputStream inputStream){
        ArrayList<String> lines = new ArrayList<>();
        try (BufferedReader reader = new BufferedReader(new InputStreamReader(inputStream))) {
            String line;
            while ((line = reader.readLine()) != null) {
                lines.add(line);
            }
        } catch (IOException e) {
			e.getMessage();
        }
        return lines;
    }
    
    public ArrayList<String> getSolution(InputStream inputStream) throws FileNotFoundException{
        ArrayList<String> filteredData = new ArrayList<>();
        boolean isUnderComment = false;
	        try (BufferedReader reader = new BufferedReader(new InputStreamReader(inputStream))) {
	            String line;
	            while ((line = reader.readLine()) != null) {
	                line = line.trim();
	                if (line.equals("//Lösung (schwarze Felder)")) {
	                    isUnderComment = true; 
	                    continue;
	                }
	                if (isUnderComment && !line.isEmpty()) {
	                    String[] lineArray = line.split(",");
	                    int firstNumn = Integer.parseInt(lineArray[0]);
	                    int secondNum = Integer.parseInt(lineArray[1]);
	                    String firstNumAsString = String.valueOf(firstNumn - 1);
	                    String secondNumAsString = String.valueOf(secondNum - 1);
	                    String newLine = firstNumAsString + "," + secondNumAsString;
	                    filteredData.add(newLine);
	                }
	            }
	        } catch (IOException e) {
				e.getMessage();
			}
        return filteredData;
    }
    
    public String[][] getData(InputStream inputStream, int rows) throws FileNotFoundException{
        String[][] data = new String[rows][rows];
        try (BufferedReader reader = new BufferedReader(new InputStreamReader(inputStream))) {
            String line;
            int rowInt = 0;
            while ((line = reader.readLine()) != null && rowInt < rows) {
                data[rowInt] = line.split(",");
                rowInt++;
            }
        } catch (IOException e) {
			e.printStackTrace();
		} 
        return data;
    }
}
