package de.hs_mannheim.informatik.domain;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.Stack;
import de.hs_mannheim.informatik.facade.HitoriAPI;

public class GameBoard {
	
	public FieldDataResult initializeFieldData(byte[] gameData, int rows, Stack<String> madeMoves, String path) throws IOException {
		InputStream newStream = new ByteArrayInputStream(gameData);		      
        String[][] data = new CSVReader().getData(newStream, rows);	
        System.out.println(data.length + " FNABLKJFABW");
        String[][] colors = new HitoriLogic().makeColorArray(data.length);
        InputStream gameStream = new ByteArrayInputStream(gameData);
        return new FieldDataResult(data, colors, gameStream);
	}
	
	public String[] getGameButtonNames() {
    	String[] buttonNames = {
            "4x4 - leicht",
            "5x5 - leicht",
            "8x8 - leicht",
            "8x8 - medium",
            "10x10 - medium",
            "15x15 - medium"
        };
    	return buttonNames;
	}

	public String[] getGamePath() {
		String[] buttonPaths = {
                "/Hitori_Spielfelder/Hitori4x4_leicht.csv",
            	"/Hitori_Spielfelder/Hitori5x5leicht.csv",
            	"/Hitori_Spielfelder/Hitori8x8leicht.csv",
            	"/Hitori_Spielfelder/Hitori8x8medium.csv",
            	"/Hitori_Spielfelder/Hitori10x10medium.csv",
            	"/Hitori_Spielfelder/Hitori15x15_medium.csv"
        };   
        return buttonPaths;
	}

	public String[] getHighscorePathNames() {
		String[] buttonPaths = {
	        "resources/Hitori_Highscores/Hitori4x4_leicht.txt",
	        "resources/Hitori_Highscores/Hitori5x5leicht.txt",
	        "resources/Hitori_Highscores/Hitori8x8leicht.txt",
	        "resources/Hitori_Highscores/Hitori8x8medium.txt",
	        "resources/Hitori_Highscores/Hitori10x10medium.txt",
	        "resources/Hitori_Highscores/Hitori15x15_medium.txt"
	    };
		return buttonPaths; 	
	}
	
	public String[] getHighscoreButtonNames() {
	    String[] buttonNames = {
	            "Highscore 4x4 - leicht",
	            "Highscore 5x5 - leicht",
	            "Highscore 8x8 - leicht",
	            "Highscore 8x8 - medium",
	            "Highscore 10x10 - medium",
	            "Highscore 15x15 - medium"
	        };
    	return buttonNames;
	}
	
	
}
