package de.hs_mannheim.informatik.domain;

import java.io.FileNotFoundException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Stack;

public class HitoriLogic {	    
	    	    
	    public String[][] makeColorArray(int size){
	        String[][] colors = new String[size][size];
	        for(int i=0;i<size;i++){
	            for(int j=0;j<size;j++){
	                colors[i][j] = "W";
	            }
	        }
	        return colors;
	    }
	    
	    public boolean checkArraySame(String[][] ergebnis,String[][] result){
	    	if(Arrays.deepEquals(ergebnis, result)) {
	    		return true;
	    	} else {
	    		return false; 
	    	}
	    }
	    
	    public boolean abgabeMöglich(InputStream inputStream, String[][] data, String[][] colors) throws FileNotFoundException{
	        String[][] result = getResult(data, colors);
	        ArrayList<String> filteredData = new CSVReader().getSolution(inputStream);
	        String[][] ergebnis = getErgebnisArray(result, filteredData);
	        boolean abgabeMöglich = checkArraySame(result, ergebnis);
	        return abgabeMöglich;
	    }
	    
	    public void addMove(String[][] colors, int i, int j, String lastLetterString, Stack<String> madeMoves){
	    	colors[i][j] += lastLetterString;
	    	String newMove = i+"."+j+"."+lastLetterString;
	    	madeMoves.push(newMove);
	    }
	    
	    public String[] getCords(int i, int j){
	        String yKoordinate = String.valueOf(i);
	        String xKoordinate = String.valueOf(j);
	        String[] position = {yKoordinate, xKoordinate};
	        return position;
	    }

	    public String[][] getResult(String[][] data, String[][] colors){
	        String[][] result = new String[data.length][data.length];
	        for(int i=0;i<data.length;i++){
	            for(int j=0;j<data.length;j++){
	                String farben = colors[i][j];
	                String lastColor = String.valueOf(farben.charAt(farben.length() - 1));
	                if(lastColor.equals("G")){
	                    lastColor = "W";
	                }
	                result[i][j] = lastColor;
	            }
	        }
	        return result;
	    }
	   
	    public String[][] getErgebnisArray(String[][] result, ArrayList<String> filteredData){
	        String[][] ergebnis = new String[result.length][result.length];
	        for(int i=0;i<result.length;i++){
	            for(int j=0;j<result.length;j++){
	                ergebnis[i][j] = "W";
	            }
	        }
	        for (String index : filteredData) { 
	            String[] parts = index.split(",");
	            int row = Integer.parseInt(parts[0].trim());
	            int col = Integer.parseInt(parts[1].trim());
	            if (row >= 0 && row < ergebnis.length && col >= 0 && col < ergebnis[row].length) {
	                ergebnis[row][col] = "B"; 
	            }
	        }
	        return ergebnis;
	    }	    
}