package de.hs_mannheim.informatik.facade;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.nio.file.Files;
import java.util.Stack;
import de.hs_mannheim.informatik.domain.*;

public class HitoriAPI {

	public static String[] getCordsCatcher(int i, int j) {
		String[] pos = new HitoriLogic().getCords(i,j);
		return pos;
	}

	public boolean abgabeMöglichCatcher(InputStream newStream, String[][] data, String[][] colors) throws FileNotFoundException {
		boolean abgabeMöglich = new HitoriLogic().abgabeMöglich(newStream, data, colors);
		return abgabeMöglich;
	}

	public void sortByTimeCatcher(byte[] data, String filename) throws IOException {
		new HighscoreManager().sortByTime(data, filename);		
	}

	public String getAvgTimeCatcher(byte[] data, String filename) throws IOException {
		String avgTime = new HighscoreManager().getAvgTime(data, filename);
		return avgTime;
	}

	public void copyResourceIfNotExistsCatcher(String resourcePathInJar, File outFile) throws IOException {
		new HighscoreManager().copyResourceIfNotExists(resourcePathInJar, outFile);		
	}

	public String[] getGameButtonNamesCatcher() {
		String[] buttonNames = new GameBoard().getGameButtonNames();
    	return buttonNames;
	}

	public String[] getGamePathCatcher() {
		String[] pathNames = new GameBoard().getGamePath();
		return pathNames; 
	}

	public String[] getHighscorePathNamesCatcher() {
		String[] pathNames = new GameBoard().getHighscorePathNames();
		return pathNames;
	}

	public String[] getHighscoreButtonNamesCatcher() {
		String[] buttonNames = new GameBoard().getHighscoreButtonNames();
		return buttonNames;
	}

	public Object[] loadHighscore(int index, String[] pathNames) {
        Object[] arr = new Object[2];
        String resourcePathInJar = pathNames[index];
        String localFileName = resourcePathInJar.substring(resourcePathInJar.lastIndexOf('/') + 1);
        File outFile = new File("resources/Hitori_Highscores", localFileName);
        try {
            copyResourceIfNotExistsCatcher(resourcePathInJar, outFile);
            byte[] data = Files.readAllBytes(outFile.toPath());  
            arr[0] = data;
            arr[1] = outFile.getPath();          		
            return arr;
        } catch (IOException e1) {
            e1.printStackTrace();
        }
		return arr;	
	}

	public static void addMoveCatcher(String[][] colors, int i, int j, String lastLetterString,
			Stack<String> madeMoves) {
    	new HitoriLogic().addMove(colors, i, j, lastLetterString, madeMoves);
	}
	
	public FieldDataResult initializeFieldDataPass(byte[] gameData, int rows, Stack<String> madeMoves, String path) throws IOException {
		FieldDataResult fdr = new GameBoard().initializeFieldData(gameData, rows, madeMoves, path);
		return fdr;
	}
}
