package de.hs_mannheim.informatik.gui;

import java.awt.BorderLayout;
import java.awt.CardLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.IOException;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;

import de.hs_mannheim.informatik.facade.HitoriAPI;

public class HighscoreMenuGUI extends JFrame {
	final String[] pathNames = new HitoriAPI().getHighscorePathNamesCatcher();
	final String[] buttonNames = new HitoriAPI().getHighscoreButtonNamesCatcher();

    public HighscoreMenuGUI(CardLayout cl, JPanel main) {
        JPanel highscorePanel = new JPanel(new BorderLayout());
        JPanel buttonPanel = new JPanel(new GridLayout(7, 1, 10, 10));
        for (int i = 0; i < buttonNames.length; i++) {
            JButton button = new JButton(buttonNames[i]);
            buttonPanel.add(button);
            final int index = i;
            button.addActionListener(e -> {
            	Object[] arr = new HitoriAPI().loadHighscore(index, pathNames);
            	byte[] data = (byte[]) arr[0];
            	String filename = (String) arr[1];
            	try {
					new HighscoreTableGUI().showHighscores(cl, main, data, filename);
				} catch (IOException e1) {
					e1.printStackTrace();
				}
            });
        }
        JButton zurückButton = new JButton("Zurück");
        zurückButton.addActionListener(e -> cl.show(main, "HAUPT"));
        buttonPanel.add(zurückButton);
        highscorePanel.setVisible(true);
        highscorePanel.setSize(700,700);        
        highscorePanel.add(buttonPanel, BorderLayout.CENTER);
        JLabel topText = new JLabel("Level für Highscore Liste auswählen!");
        highscorePanel.add(topText, BorderLayout.NORTH);
        main.add(highscorePanel, "HIGHSCORES");
        cl.show(main, "HIGHSCORES");
    }
}
