package de.hs_mannheim.informatik.gui;

import java.awt.BorderLayout;
import java.awt.CardLayout;
import java.awt.GridLayout;
import java.io.BufferedReader;
import java.io.ByteArrayInputStream;
import java.io.File;
import java.io.IOException;
import java.io.InputStreamReader;
import java.nio.charset.StandardCharsets;
import java.nio.file.Files;
import java.util.ArrayList;
import java.util.List;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;

import de.hs_mannheim.informatik.facade.HitoriAPI;

public class HighscoreTableGUI {
    public void showHighscores(CardLayout cl, JPanel main, byte[] data, String filename) throws IOException {    	
    	new HitoriAPI().sortByTimeCatcher(data,filename);
        data = Files.readAllBytes(new File(filename).toPath());
        JPanel highscorePanel = new JPanel(new BorderLayout());
        List<String> lines = new ArrayList<>();
        try (BufferedReader reader = new BufferedReader(
                new InputStreamReader(new ByteArrayInputStream(data), StandardCharsets.UTF_8))) {
            String line;
            while ((line = reader.readLine()) != null) {
                lines.add(line);
            }
        } catch (IOException e) {
        	e.printStackTrace();
        }
        
        boolean hasContent = false;
        for (String l : lines) {
            if (!l.trim().isEmpty()) {
                hasContent = true;
                break;
            }
        }
        if(hasContent) {
	        JPanel entryPanel = new JPanel(new GridLayout(lines.size(), 1, 10, 10));
	        for (String s : lines) {
	            JLabel text = new JLabel(s);
	            entryPanel.add(text);
	        }
	        highscorePanel.add(entryPanel, BorderLayout.CENTER);
	        
	        String avgString = new HitoriAPI().getAvgTimeCatcher(data,filename);
	        JLabel avgTime = new JLabel(avgString);
	        highscorePanel.add(avgTime, BorderLayout.NORTH);
        } else {
        	JLabel text = new JLabel("Noch kein Highscore eingetragen.");
        	highscorePanel.add(text, BorderLayout.CENTER);
        }
        JButton okButton = new JButton("OK");
        highscorePanel.add(okButton, BorderLayout.SOUTH);
        okButton.addActionListener(e -> cl.show(main, "HIGHSCORES"));
        highscorePanel.setVisible(true);
        highscorePanel.setSize(600, 600);
        main.add(highscorePanel, "HIGHSCOREEINTRAG");
        cl.show(main, "HIGHSCOREEINTRAG");
    }
}
