package de.hs_mannheim.informatik.gui;

import java.awt.BorderLayout;
import java.awt.CardLayout;
import java.awt.GridLayout;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.util.Stack;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import de.hs_mannheim.informatik.domain.FieldDataResult;
import de.hs_mannheim.informatik.facade.HitoriAPI;

public class MenuGUI extends JFrame {
	
	private CardLayout cl = new CardLayout();
	private JPanel main = new JPanel(cl);
	private String[] filepath = {"", ""};
	private byte[] gameData; 
		
    public MenuGUI(){
        JPanel menuPanel = new JPanel(new BorderLayout());
        JPanel buttonPanel = new JPanel(new GridLayout(7,1,10,10));
        
        final String[] buttonNames = new HitoriAPI().getGameButtonNamesCatcher();
        final String[] buttonPaths = new HitoriAPI().getGamePathCatcher();
        
        for(int i=0;i<buttonNames.length;i++){
            JButton button = new JButton(buttonNames[i]);
            buttonPanel.add(button);
            int[] count = {i};
            String[] num = buttonNames[i].split("x"); 
            button.addActionListener(e -> {
                int j = count[0];
                filepath[0] = buttonPaths[j];
                filepath[1] = num[0];
                loadGame(filepath, cl, main, gameData); 
            });
        }
        JButton highscoreButton = new JButton("Highscores");
        highscoreButton.addActionListener(e -> {
            new HighscoreMenuGUI(cl, main);
        });
	    buttonPanel.add(highscoreButton);
	    menuPanel.add(buttonPanel, BorderLayout.CENTER);
	    JLabel topText = new JLabel("Wählen Sie ein Level aus!");
	    menuPanel.add(topText, BorderLayout.NORTH);
	    setVisible(true);
	    setSize(700,700);
		setDefaultCloseOperation(EXIT_ON_CLOSE);
	    add(main);
	    main.add(menuPanel, "HAUPT");
		cl.show(main, "HAUPT");
    }
    
	public void loadGame(String[] filepath, CardLayout cl, JPanel main, byte[] gameData) {
		try (InputStream inputStream = GameGUI.class.getResourceAsStream(filepath[0])) {
            if (inputStream != null) {
            	String path=filepath[0];
            	ablauf(cl, main, inputStream, Integer.parseInt(filepath[1]), path);
            } else {
                throw new FileNotFoundException("Resource not found: " + filepath[0]);
            }
        } catch (IOException e1) {
			e1.getMessage();
		}
	}
	
	public void passOn(String[][] data, String[][] colors, InputStream gameStream) {
		
		
	}
	
	 public void ablauf(CardLayout cl, JPanel main, InputStream inputStream, int rows, String path) throws IOException {
	        Stack<String> madeMoves = new Stack<>();
	        byte[] gameData = inputStream.readAllBytes();
	        FieldDataResult fdrDTO = new HitoriAPI().initializeFieldDataPass(gameData, rows, madeMoves, path);
	        String[][] data = fdrDTO.getData();
	        String[][] colors =fdrDTO.getColors();
	        InputStream gameStream = fdrDTO.getGameStream();
	        new GameGUI().paintGame(cl, main, gameStream, madeMoves, data, path, colors);
	}
}
