package de.hs_mannheim.informatik.test;

import static org.junit.jupiter.api.Assertions.*;
import org.junit.jupiter.api.Test;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.Arrays;

import de.hs_mannheim.informatik.domain.CSVReader;
import de.hs_mannheim.informatik.domain.HitoriLogic;

class HitoriLogicTest{

	@Test
	void makeColorArrayTest1() {
		String[][] array3x3 = {
            {"W", "W", "W"},
            {"W", "W", "W"},
            {"W", "W", "W"}
        };
		assertTrue(Arrays.deepEquals(array3x3, new HitoriLogic().makeColorArray(3)));
	}

    @Test
	void makeColorArrayTest2() {
		String[][] array3x2 = {
            {"W", "W", "W"},
            {"W", "W", "W"},
        };
		assertFalse(Arrays.deepEquals(array3x2, new HitoriLogic().makeColorArray(3)));
	}

    @Test
	void checkArraySameTest1() {
		String[][] data = {
            {"W", "B", "W", "W"},
            {"W", "W", "W", "B"},
            {"W", "B", "W", "W"},
            {"B", "W", "W", "B"}};
        String[][] colors = {
            {"W", "W", "W", "W"},
            {"W", "W", "W", "B"},
            {"W", "B", "W", "W"},
            {"B", "W", "W", "B"}};
            assertFalse(new HitoriLogic().checkArraySame(data, colors));
	}

    @Test
	void checkArraySameTest2() {
		String[][] data = {
            {"W", "B", "W", "W"},
            {"W", "W", "W", "B"},
            {"W", "B", "W", "W"},
            {"B", "W", "W", "B"}};
        String[][] colors = {
            {"W", "B", "W", "W"},
            {"W", "W", "W", "B"},
            {"W", "B", "W", "W"},
            {"B", "W", "W", "B"}};
        
        assertTrue(new HitoriLogic().checkArraySame(data, colors));
	}

    @Test
	void checkArraySameTest3() {
		String[][] data = {
            {"B", "W", "W", "B", "W"},
            {"W", "W", "B", "W", "W"},
            {"B", "W", "W", "B", "W"},
            {"W", "W", "B", "W", "W"},
            {"B", "W", "W", "W", "B"}};
        String[][] colors = {
            {"W", "W", "W", "W", "W"},
            {"W", "W", "W", "B", "W"},
            {"W", "B", "W", "W", "W"},
            {"W", "B", "W", "W", "W"},
            {"W", "B", "W", "W", "W"}};
            assertFalse(new HitoriLogic().checkArraySame(data, colors));
	}

    @Test
	void checkArraySameTest4() {
		String[][] data = {
            {"B", "W", "W", "B", "W"},
            {"W", "W", "B", "W", "W"},
            {"B", "W", "W", "B", "W"},
            {"W", "W", "B", "W", "W"},
            {"B", "W", "W", "W", "B"}};
        String[][] colors = {
            {"B", "W", "W", "B", "W"},
            {"W", "W", "B", "W", "W"},
            {"B", "W", "W", "B", "W"},
            {"W", "W", "B", "W", "W"},
            {"B", "W", "W", "W", "B"}};
        assertTrue(new HitoriLogic().checkArraySame(data, colors));
	}

    @Test
	void getCordsTest1() {
		String[] array = {"3", "4"};
		assertFalse(Arrays.deepEquals(array, new HitoriLogic().getCords(3, 3)));
	}

    @Test
	void getCordsTest2() {
		String[] array = {"3", "4"};
		assertTrue(Arrays.deepEquals(array, new HitoriLogic().getCords(3, 4)));
	}
    
    @Test
	void checkArraySameTest5() throws FileNotFoundException {
    	String[][] data = {
    			 {"B", "W", "B", "W", "W", "B", "W", "W", "W", "B"},
                 {"W", "W", "W", "B", "W", "W", "B", "W", "W", "W"},
                 {"W", "B", "W", "W", "W", "B", "W", "W", "B", "W"},
                 {"W", "W", "W", "W", "W", "W", "W", "B", "W", "B"},
                 {"B", "W", "B", "W", "B", "W", "B", "W", "W", "W"},
                 {"W", "B", "W", "W", "W", "B", "W", "W", "W", "B"},
                 {"W", "W", "W", "W", "B", "W", "W", "W", "B", "W"},
                 {"B", "W", "B", "W", "W", "B", "W", "W", "W", "W"},
                 {"W", "W", "W", "B", "W", "W", "B", "W", "B", "W"},
                 {"B", "W", "B", "W", "W", "W", "W", "W", "W", "B"}};
        String[][] colors = {
        		 {"B", "W", "B", "W", "W", "B", "W", "W", "W", "B"},
                 {"W", "W", "W", "B", "W", "W", "B", "W", "W", "W"},
                 {"W", "B", "W", "W", "W", "B", "W", "W", "B", "W"},
                 {"W", "W", "W", "W", "W", "W", "W", "B", "W", "B"},
                 {"B", "W", "B", "W", "B", "W", "B", "W", "W", "W"},
                 {"W", "B", "W", "W", "W", "B", "W", "W", "W", "B"},
                 {"W", "W", "W", "W", "B", "W", "W", "W", "B", "W"},
                 {"B", "W", "B", "W", "W", "B", "W", "W", "W", "W"},
                 {"W", "W", "W", "B", "W", "W", "B", "W", "B", "W"},
                 {"B", "W", "B", "W", "W", "W", "W", "W", "W", "B"}};
        assertTrue(new HitoriLogic().checkArraySame(data, colors));
    }
    
    @Test
	void checkArraySameTest6() {
    	String[][] data = {
                {"B", "W", "B", "W", "W", "B", "W", "W", "W", "B"},
                {"W", "W", "W", "B", "W", "W", "B", "W", "W", "W"},
                {"W", "B", "W", "W", "W", "B", "W", "W", "B", "W"},
                {"W", "W", "W", "W", "W", "W", "W", "B", "W", "B"},
                {"B", "W", "B", "W", "B", "W", "B", "W", "W", "W"},
                {"W", "B", "W", "W", "W", "B", "W", "W", "W", "B"},
                {"W", "W", "W", "W", "B", "W", "W", "W", "B", "W"},
                {"B", "W", "B", "W", "W", "B", "W", "W", "W", "W"},
                {"W", "W", "W", "B", "W", "W", "B", "W", "B", "W"},
                {"B", "W", "B", "W", "W", "W", "W", "W", "W", "B"}};
        String[][] colors = {
                {"B", "W", "B", "W", "W", "B", "W", "W", "W", "B"},
                {"W", "W", "W", "B", "W", "W", "B", "W", "W", "W"},
                {"W", "B", "W", "W", "W", "B", "W", "W", "B", "W"},
                {"W", "W", "W", "W", "W", "W", "W", "B", "W", "B"},
                {"B", "W", "B", "W", "B", "W", "B", "W", "W", "W"},
                {"W", "B", "W", "W", "W", "B", "W", "W", "W", "B"},
                {"W", "W", "W", "W", "B", "W", "W", "W", "B", "W"},
                {"B", "W", "B", "W", "W", "B", "W", "W", "W", "W"},
                {"W", "W", "W", "B", "W", "W", "B", "W", "B", "W"},
                {"B", "W", "B", "W", "W", "W", "W", "W", "W", "W"}}; 
			assertFalse(new HitoriLogic().checkArraySame(data, colors));
	}
    
    @Test
    void getResultTest1() {
    	String[][] data = {
    			{"W", "G", "B", "W"},	
    			{"G", "B", "W", "G"},	
    			{"B", "W", "G", "B"},	
    			{"W", "G", "B", "W"}};
    	String[][] colors = {
    			{"W", "G", "B", "W"},	
    			{"G", "B", "W", "G"},	
    			{"B", "W", "G", "B"},	
    			{"W", "G", "B", "W"}};
    	String[][] array = {
    			{"W", "W", "B", "W"},	
    			{"W", "B", "W", "W"},	
    			{"B", "W", "W", "B"},	
    			{"W", "W", "B", "W"}};
    	    assertTrue(Arrays.deepEquals(array, new HitoriLogic().getResult(data, colors)));
    }
    
    @Test
    void getResultTest2() {
    	String[][] data = {
    			{"W", "G", "B", "W"},	
    			{"G", "B", "W", "G"},	
    			{"B", "W", "G", "B"},	
    			{"W", "G", "B", "W"}};
    	String[][] colors = {
    			{"W", "G", "B", "W"},	
    			{"G", "B", "W", "G"},	
    			{"B", "W", "G", "B"},	
    			{"W", "G", "B", "W"}};
    	String[][] array = {
    			{"W", "W", "B", "W"},	
    			{"G", "B", "W", "W"},	
    			{"B", "W", "W", "B"},	
    			{"W", "W", "B", "W"}};
    	    assertFalse(Arrays.deepEquals(array, new HitoriLogic().getResult(data, colors)));
    }
    
    @Test
    void makeColorArrayTest3() {
    	String[][] colors = {
    			{"W", "W", "W", "W"},
    			{"W", "W", "W", "W"},
    			{"W", "W", "W", "W"},
    			{"W", "W", "W", "W"}};
    	assertTrue(Arrays.deepEquals(colors, new HitoriLogic().makeColorArray(4)));
    }
    
    @Test
    void makeColorArrayTest4() {
    	String[][] colors = {
    			{"B", "W", "W", "W"},
    			{"B", "W", "W", "W"},
    			{"B", "W", "W", "W"},
    			{"B", "W", "W", "W"}};
    	assertFalse(Arrays.deepEquals(colors, new HitoriLogic().makeColorArray(4)));
    }
    
	@Test
    void getErgebnisArrayTest1() throws IOException {
    	String[][] ergebnis1 = {
    	{"W", "B", "W", "W"},
    	{"W", "W", "W", "B"},    	
    	{"W", "B", "W", "W"},    	
    	{"B", "W", "W", "B"}};
    	String path = "/Hitori_Spielfelder/Hitori4x4_leicht.csv";
    	InputStream inputStream = getClass().getResourceAsStream(path);
        ArrayList<String> filteredData = new CSVReader().getSolution(inputStream);
    	InputStream newStream = getClass().getResourceAsStream(path);
    	int rows = 4;
        String[][] data = new CSVReader().getData(newStream, rows);		        
    	assertTrue(Arrays.deepEquals(ergebnis1, new HitoriLogic().getErgebnisArray(data, filteredData)));  	
    }
    
	@Test
    void getErgebnisArrayTest2() throws IOException {
    	String[][] ergebnis1 = {
    	{"W", "W", "W", "W"},
    	{"W", "W", "W", "W"},    	
    	{"W", "W", "W", "W"},    	
    	{"W", "W", "W", "W"}};
    	String path = "/Hitori_Spielfelder/Hitori4x4_leicht.csv";
    	InputStream inputStream = getClass().getResourceAsStream(path);
        ArrayList<String> filteredData = new CSVReader().getSolution(inputStream);
    	InputStream newStream = getClass().getResourceAsStream(path);
    	int rows = 4;
        String[][] data = new CSVReader().getData(newStream, rows);		      
    	assertFalse(Arrays.deepEquals(ergebnis1, new HitoriLogic().getErgebnisArray(data, filteredData))); 
    }
	
	@Test
	void abgabeMöglichTest1() throws FileNotFoundException{
		String path = "/Hitori_Spielfelder/Hitori4x4_leicht.csv";
    	InputStream inputStream = getClass().getResourceAsStream(path);
		String[][] data = {
				{"W", "B", "W", "W"},
				{"W", "W", "W", "B"},
				{"W", "B", "W", "W"},
				{"B", "W", "W", "B"}
		};
		String[][] colors = {
				{"W", "WGBBB", "W", "W"},
				{"W", "W", "W", "WGB"},
				{"W", "WGB", "W", "W"},
				{"WBGGGGB", "W", "W", "WGB"}
		};
		boolean expected = true;
		assertEquals(expected, new HitoriLogic().abgabeMöglich(inputStream, data, colors));
	}
	
	@Test
	void abgabeMöglichTest2() throws FileNotFoundException{
		String path = "/Hitori_Spielfelder/Hitori4x4_leicht.csv";
    	InputStream inputStream = getClass().getResourceAsStream(path);
		String[][] data = {
				{"W", "W", "W", "W"},
				{"W", "W", "W", "W"},
				{"W", "W", "W", "W"},
				{"W", "W", "W", "W"}
		};
		String[][] colors = {
				{"W", "B", "W", "W"},
				{"W", "W", "W", "B"},
				{"W", "B", "W", "W"},
				{"B", "W", "W", "B"}
		};
		boolean expected = false;
		assertNotEquals(expected, new HitoriLogic().abgabeMöglich(inputStream, data, colors));
	}
}